﻿using System;
using System.Configuration;
using System.Net;
using System.Web.Mvc;
using Newtonsoft.Json.Linq;


namespace TwitterPractice.Controllers
{
    public class HomeController : Controller
    {
        private static string title = "Twitter Practice!";
        private static string requestTemplate;

        public HomeController()
            : base()
        {
            requestTemplate = ConfigurationManager.AppSettings["TwitterRequestTemplate"];
        }

        public ActionResult Index()
        {
            ViewBag.HasQsVars = (Request.QueryString.Keys.Count > 0);
            ViewBag.QueryString = Request.QueryString;
            ViewBag.Message = title;
            string username = Request.QueryString["username"];
            if (null == username)
            {
                username = "meatballhat";
            }
            ViewBag.UserTimeline = GetTwitterStream(username);
            ViewBag.Username = username;
            return View();
        }

        private JArray GetTwitterStream(string username="meatballhat")
        {
            string requestUrl = String.Format(requestTemplate, username);
            WebClient req = new WebClient();
            return JArray.Parse(req.DownloadString(requestUrl));
        }
    }
}
